/************************************************************************
*  UnconstrainedOpt.h (Unconstrained Minimization Algorithm Definition)
*
*  Version:                     1.1
*  Date:                        2/17/94
*  Author:                      O. Knueppel
*************************************************************************/

#ifndef __UNCONSTOPT__
#define __UNCONSTOPT__

#include "applist.h"
#include "veclist.h"

VOID UnconstrainedOptimization (SOLUTIONLIST & SolutionList,
				APPROXIMATIONLIST & ApproximationList,
				INT Iterations, INT BranchLevels, REAL Eps,
				REAL RaiseFactor, REAL HeuristicExpandFactor,
				REAL & LowerBound, REAL & UpperBound,
				BOOL UseDerivatives = FALSE);

VOID StartUnconstrainedOptimization (SOLUTIONLIST & SolutionList,
				     APPROXIMATIONLIST & ApproximationList,
				     INT Iterations, INT BranchLevels, REAL Eps,
				     REAL RaiseFactor, REAL HeuristicExpandFactor,
				     REAL & LowerBound, REAL & UpperBound,
				     INTERVAL_VECTOR & TheDomain,
				     REAL (* TheRealFunction)(VECTOR &),
				     INTERVAL (* TheIntervalFunction)(INTERVAL_VECTOR &),
				     INTERVAL_VECTOR (* TheIntervalGradient)(INTERVAL_VECTOR &) = 0,
				     INTERVAL_MATRIX (* TheIntervalHessian)(INTERVAL_VECTOR &) = 0);

VOID CleanUpLists (SOLUTIONLIST & SolutionList,
		   APPROXIMATIONLIST & ApproximationList,
		   REAL Eps, REAL LowerBound, REAL UpperBound);

VOID UpdateLowerBound (SOLUTIONLIST & SolutionList, REAL & LowerBound);

#endif /* __UNCONSTOPT__ */

