/************************************************************************
*  VecList.h (Solution List Definitions)
*
*  Version:                     1.2
*  Date:                        2/18/94
*  Author:                      O. Knueppel
*************************************************************************/

#ifndef __VECLIST__
#define __VECLIST__

#include "ivalmat.h"

class SOLUTIONLIST_ELEMENT {
 public:
  INTERVAL        FunctionValue;
  INTERVAL_VECTOR Box;
  SOLUTIONLIST_ELEMENT() {};
  SOLUTIONLIST_ELEMENT (INTERVAL &, INTERVAL_VECTOR &);
  SOLUTIONLIST_ELEMENT & operator = (SOLUTIONLIST_ELEMENT &);
  friend ostream & operator << (ostream &, SOLUTIONLIST_ELEMENT &);
};

#undef LISTOBJECT
#undef LIST
#undef LIST_ELEMENT
#undef LISTCMPFUNC
#define LISTCMPFUNC  SOLUTIONLIST_CMPFUNC
#define LIST_ELEMENT SOLUTIONLIST_ELEMENT
#define LIST         SOLUTIONLIST
#define LISTOBJECT   SOLUTIONLISTOBJECT
#include "linlist.hge"

BOOL SolutionCmp (SOLUTIONLIST_ELEMENT &, SOLUTIONLIST_ELEMENT &);
VOID Cleanup (SOLUTIONLIST &, REAL);
REAL Lowest (SOLUTIONLIST &);

VOID Append (SOLUTIONLIST &, INTERVAL_VECTOR &, INTERVAL &);
VOID Insert (SOLUTIONLIST &, INTERVAL_VECTOR &, INTERVAL &);
VOID Append_First (SOLUTIONLIST &, INTERVAL_VECTOR &, INTERVAL &);
VOID Append (SOLUTIONLIST &, SOLUTIONLIST &);

#endif /* _VECLIST */



